Contents

ADVANSYS

Formativ

GroupWise Customization Made Easy!

Administrators Guide

Guide to administration of Formativ 1.6 for Novell GroupWise

Advansys Formativ Administration Guide

Information in this document is subject to change without notice. The example companies, products and people are purely fictitious. Without limiting the rights under copyright, no part of this document may be reproduced, stored or introduced into a retrieval system, or transmitted in any form without prior written approval of Advansys corporation.

Advansys may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering the subject matter in this document. Except as expressly provided in any written license agreement from Advansys, the furnishing of this document does not give you any license to these patents, trademarks, copyrights or other intellectual property.

Copyright © 2003 Advansys Pty Limited. All rights reserved.

Formativ is a trademark of Advansys Pty Limited in Australia and other countries.

GroupWise is a registered trademark of Novell Inc..

Visual Basic Script is a registered trademark of Microsoft Corporation.


Finding Information

This section provides information about using Formativ documentation, installing and configuring the product and obtaining support from Advansys.

For information about | See
Administering Formativ using Novell Directory Services (eDirectory/NDS) or the File System | This guide
The Formativ Applet Language Extensions | The Formativ Language Guide
The Formativ Business Solutions Pack applets | The Formativ Business Solutions Pack Guide
Developing Solutions with Formativ | The Formativ Programmers Guide
Visual Basic Script | Microsoft's Visual Basic Script web site
Novell GroupWise Development Resources | Novell DeveloperNet web site
All other aspects of Formativ development |


Getting Help from Advansys Technical Support

If you are currently online, select one of the following links to access the appropriate support resource:

Formativ Updates Page

There may be an update that addresses your problem. This page should be your first stop should you encounter a problem.

Formativ Support Page

The Formativ Support page contains links to various support resources.

Advansys Formativ Frequently Asked Questions (FAQ)

Advansys maintains a list of frequently asked questions about Formativ. Check this page to see if the answer to your question has already been documented.

Formativ Support Forums

Advansys provides technical support for Formativ via online moderated forums. These web-based forums are moderated by Advansys technical staff and represent the primary source of support for Formativ. Feel free to log in and post a question or search the existing forums to see if your question has already been answered.


Administrator Quick Start Guide

If you are familiar with managing Novell eDirectory/NDS objects, below is a quick start guide for setting up your first Formativ eDirectory configuration. This guide will reference the structure shown in Figure 1.

IMPORTANT: If you are upgrading from Formativ 1.0.x to Formativ 1.5, please see README.TXT for important information regarding upgrading your eDirectory/NDS Formativ objects.

NOTE: Please note that in this guide that the eDirectory term 'property' may be interchanged with the eDirectory term 'attribute'. In addition, any references to eDirectory can be interchanged with Novell Directory Services (NDS).

Figure 1 - Formativ objects in a Formativ Organizational Unit

Preparatory Steps

  1. Login to the network with the appropriate eDirectory Administrator rights.
  2. Install the Formativ Administration Tools, the ConsoleOne and/or the NWAdmin snap-ins by running the second admintoolssetup.exe installation program.

  3. Extend the eDirectory Schema by running the Schema Wizard at the end of the admintoolssetup.exe snap-in installation process or from the Start|Programs|Advansys Formativ Schema Wizard|SchemaWizard menu entry. The NetWare Client must be installed on the workstation from which the Schema Wizard is run.

  4. Install Formativ Admin on your workstation (which must have the GroupWise Windows client installed) by running the formativadmin.exe installation program.

Creating the Formativ eDirectory Objects - The FormativAdministrator Object

To administer Formativ Applet Library and Applet objects, you must be able to run Formativ Admin in Administrator Mode.

  1. Create an Organizational Unit (OU) called Formativ (or other name as preferred) under the Organization (O) object. The Formativ OU is not a requirement, it just makes organization of your main Formativ objects a little tidier within the tree.

  2. Under the Formativ OU, create an Organizational Role called FormativAdministrator (the object's name must be spelt exactly as shown).

  3. To enable your Formativ Admin to operate in Administrator Mode, add your own User object to the Security Equal To Me list of the FormativAdministrator object.

Creating the Formativ eDirectory Objects - The Formativ Applet Library Object

To be able to create Formativ Applet objects, you must first create a Formativ Applet Library object, which also defines who can administer the library.

  1. Under the Formativ OU, create a Formativ Applet Library object called Corporate Applets (or other name of your choice depending on the intended use of the library).

  2. Configure the Library Administrators property page by adding your User object to the list of library administrators.

  3. Highlight the library and, by using the 'Trustees of this object' option, add the FormativAdministrator Organizational Role object as a trustee of the library. Enable the [Entry] Browse, Create, Delete, Rename, Inheritable and [All Attributes] Compare, Read, Write, Inheritable rights to the library object.

Creating the Formativ eDirectory Objects - The Formativ Configuration Object

The Formativ Configuration object is the key to defining which Formativ features are enabled for a user, and which applet libraries (hence applets) a user can access.

  1. Under the Formativ OU, create a Formativ Configuration object and give it an appropriate name for your requirements. For example, if the Configuration object is to be used as a default corporate shared configuration, you could call it 'Corporate Formativ Configuration' or similar.

  2. In the Applet Libraries property page of the Configuration object, add the previously created 'Corporate Applets' object to the applet library list. Note: For future reference, a configuration object can reference as many Applet Library objects as desired.

  3. In the Formativ Configuration property page of the Configuration object, you would normally check the settings you wish to enable for the users of this Configuration object. For the purposes of this quick start introduction, check ALL the options on this page. [Under most circumstances, a corporate configuration would normally only provide the minimum features you wish the average user to have access to, such as Formativ is enabled, Reload shared applets on GroupWise client startup, Integrations enabled and perhaps the Favorites menu enabled, Run menu enabled]. You can change these options at any time - they become active for a user following a GroupWise client restart.

Configure access to the Formativ Configuration Object

A Formativ user's User object must link to a single Formativ Configuration object. You use the Associate button on the Configuration object's property page to assign the Configuration object to a target eDirectory object. The full range of options for linking a User object to a Configuration object is discussed in the The Configuration Object and eDirectory Rights sections. For the purposes of this quick start introduction, your User object will be configured to link directly to the 'Corporate Formativ Configuration' object.

In the Formativ Configuration property page of the 'Corporate Formativ Configuration' object, use the Associate button to select your own User object.

Using the Formativ eDirectory configuration

Now that you have configured eDirectory with a basic Formativ configuration, you can test its operation. Ensure that you are logged in to the network as the user you modified above and then start your GroupWise client. Through FormativCentral (Applets|Manage Applets or by selecting the Manage all your macros from Formativ Central toolbar button) you should now be able to see both the My Applets local applets and the eDirectory Corporate Applets Formativ Applet Library. See the section Using the client in Administration Mode for details on how to create, edit, delete, rename and publish applets to an eDirectory applet library.

Additional Tasks

The above steps show you how to set up a user (yourself in the case above) as an administrator of a Formativ Applet Library. The next step is to configure a user who is not a Formativ Administrator, but a Formativ user, which will be the majority of cases. Configuration of a standard Formativ user is a straightforward variation of the steps outlined above, so we will not go into exhaustive details here beyond suggesting the steps you may take.

  1. Create a new Configuration object in the location of your choice and, for example, call it 'Admin Configuration'. For the purposes of the exercise, you may wish to create the object underneath the Formativ OU.

  2. Add the 'Corporate Applets' library to the Admin Configuration's library list.

  3. Select all options on the Admin Configuration's Formativ Configuration property page.

  4. Open the details view of your own User object. Select your User object's See Also property page and add the 'Admin Configuration' object to the See Also list.

  5. Display the details of the 'Corporate Formativ Configuration' Configuration object. Disable the Create and manage personal applets and the Enabled when using GroupWise Remote options in the Formativ Configuration page of the Corporate Formativ Configuration object.

  6. Select another User object of a user who will be able to run the corporate applets but who will not be able to create/edit them (not even personal applets). We will refer to this user as 'Standard User', who will have Formativ Runtime (not Formativ Admin) installed. Of course, as will be the case with the majority of Formativ users, they will not be configured as a Formativ Library Administrator because this has no effect when running Formativ Runtime.

  7. In the Formativ Configuration property page of the 'Corporate Formativ Configuration' object, use the Associate button to select the Standard User object. Note: If desired, you could choose another object, such as Group, Organizational Unit or Organization, where the Standard User is a subordinate or a member (in the case of a Group). Please refer to The Configuration Object and eDirectory Rights sections for details.

  8. You can then install Formativ Runtime on another workstation and login as the newly configured Formativ user, Standard User. Alternatively, you can login as the Standard User on your workstation. In either case, depending on whether you are logged in as yourself or the Standard User, when you start the GroupWise client you should see the Formativ features change according to the settings in the user's associated Formativ Configuration object (Admin Configuration for yourself and Corporate Formativ Configuration for Standard User).

  9. When you are logged in as the Formativ Library Administrator, you can experiment with publishing applets to the Corporate Applets library and see the effects on the shared applets to which the Standard User has access. In addition, when logged in as the eDirectory administrator, you can vary the features specified in the Corporate Formativ Configuration and see the effect on the Formativ features available to Standard User.

  10. Once you understand the relationships between the Formativ objects and how to reference Formativ Configuration objects from User, Group, Organizational Unit and Organization objects, you will be in a position to create and configure as many Formativ Configuration and Applet Library objects/Library administrators as required by your organization.


Planning your Formativ Installation

Using Novell eDirectory/NDS to administer Formativ is straightforward. However, like any eDirectory-based system, you should plan the implementation of the Formativ system within your directory. Even though Formativ places only small demands on your network, the main consideration during planning should be potential network traffic. In order to get the best performance and minimize network traffic, you should consider the placement of Formativ objects within your eDirectory tree. In particular, if you have a WAN environment, consider the location of partitions when creating Formativ Configuration and Applet Library Objects. As a general recommendation, you should place the Formativ Applet Library and Formativ Configuration objects close to the users who will access them.

Figure 1 - A view of a simplified eDirectory tree which includes Formativ objects

Some key questions to consider during the planning process are:

How many Formativ Applet Library Objects do you need for your organization? For example, you may wish to have a library to be shared with all users, an additional library for a specific department, such as Engineering and one for applet development.

How many Formativ Configuration Objects do you need? The Configuration object defines which Formativ features and which Applet Libraries are available to a user. Since there can only be one Configuration object per user, it is important to plan how many Configuration objects are needed and how they should be linked to one or more users (see The Configuration Object for more information).

Who should be an Applet Library Administrator? You will need to decide which users will manage applets within your Applet Libraries, allocate the appropriate eDirectory Rights to those library administrators, and configure them as Administrators (see The Applet Library Object, Administration Mode and Using the client in Administration Mode).


Installation Steps

Step 1 - Plan your Installation

Take some time to plan how you want your GroupWise users to access Formativ applets and the Formativ Admin/Formativ Runtime features. A planning guide can be found in the section Planning your Formativ Installation.

Step 2 - Install the Administration Tools

To create and manage Formativ eDirectory objects you need to install the Formativ eDirectory Administration Tools: a ConsoleOne 1.2x or NWAdmin32/NT/95 snap-ins. Further details are found in the section Installing eDirectory Administration Tools.

Step 3 - Extend the eDirectory Schema

To configure Formativ centralized management for use with eDirectory or eDirectory, you need to extend the schema to include the Formativ eDirectory classes and attributes. Instructions for extending the eDirectory schema are in the section Extending the Schema.

Step 4 - Create Formativ objects in eDirectory and assign rights to users

To make shared applets available to users, as a minimum eDirectory Formativ installation you will need to create a FormativAdministrator Organizational Role and at least one Configuration and one Applet Library Object. To allow addition, modification and deletion of applets within a Applet Library, you will need to assign the appropriate eDirectory rights to the Formativ Administrator, who should also be configured as the Applet Library Administrator. See the following sections for details: Formativ eDirectory Objects, Administrator Mode, Using the client in Administrator Mode and eDirectory Rights.


NDS Administration Tools

eDirectory Administration Tools

Advansys has developed both ConsoleOne 1.2x and NWAdmin snapins to administer the Formativ eDirectory objects. See the Installing eDirectory Administration Tools section on how these snapins are installed. The use of these snapins is described in the sections under Formativ eDirectory Objects.

We strongly recommend that you check the Novell web site to ensure you have the latest versions of ConsoleOne and NWAdmin installed.


Installing NDS Administration Tools

Installing eDirectory Administration Tools

In order to administer Formativ with eDirectory, you must install the administration tools to your PC. The administration tools consist of snap-ins for ConsoleOne, NWAdmin95, NWAdminNT and NWAdmin32.

Note: You must also extend the eDirectory schema in order to administer Formativ. Installing the eDirectory administration tools does NOT extend the schema - you must extend the schema separately through the Schema Wizard program, which is the default option at the end of the administration tools setup program.

Installing the eDirectory Administration Tools

  1. Start the Formativ administration program, admintoolssetup.exe.

  2. Press Next to proceed beyond the Formativ Administration Tools Setup Welcome dialog.

  3. Press Next after reading the instructions dialog.
  4. Select the snapins which you require installed: ConsoleOne and/or NWAdmin. Note that the ConsoleOne snapins are only supported for a local PC and not a network ConsoleOne installation.
  5. Select the folder where the Schema Wizard will be installed.
  6. Select the Program Group where the Schema Wizard will be located.

  7. Select the target server name from the list, where the Formativ NWAdmin snapins will be installed (only if selected in Step 4).

  8. Press Next at the ready to install dialog.

  9. If successful, the Installation Complete dialog will appear and you are ready to extend the eDirectory schema using the Schema Wizard. If you do not wish to run the Schema Wizard at this time, just uncheck the Run the Schema Wizard now option. When you wish to extend the schema, just run the Schema Wizard from the Windows Start|Programs|Advansys Formativ Schema Wizard|Schema Wizard menu option.


Extending the Schema

In order to use the eDirectory/NDS administration feature of Formativ, you must first extend the schema to include the new Formativ eDirectory objects. Existing Formativ 1.0 users must also update the schema to use some new Formativ 1.5 features, such as intelligent applet caching. Extending the schema is achieved by running the Schema Wizard program, which is installed by the Formativ administration installation program, admintoolssetup.exe. You can initiate the Schema Wizard from the final stage of the admintoolssetup.exe program or from the Windows Start|Programs|Advansys Formativ Schema Wizard|Schema Wizard menu option. Prior to running the Schema Wizard, you must ensure you have logged in with the appropriate eDirectory Administrator rights to extend the eDirectory schema. To administer Formativ via eDirectory, you should have already installed the ConsoleOne and/or NWAdmin snapins using the admintoolssetup.exe installation program (See Installing eDirectory Administration Tools).

Note: Formativ does NOT extend any of the base eDirectory classes, such as User. This means that, after removing all Formativ objects from the eDirectory tree, you can completely remove the schema extensions at a later date.

Installing or Removing the Formativ eDirectory Schema Extensions

  1. Install the Schema Wizard and the ConsoleOne and/or the NWAdmin snapins using the Formativ 1.5 administration program, admintoolssetup.exe.

  2. Initiate the Schema Wizard at the end of the admintoolssetup.exe program or from the Windows Start|Programs|Advansys Formativ Schema Wizard|Schema Wizard menu option.

  3. Press Next if you are logged in with the appropriate rights to modify the eDirectory schema. Important Note: You should be authenticated to the eDirectory tree for which you intend to extend the schema.

  4. By clicking on the appropriate radio button, select whether you wish to Add/Update or Remove the Formativ eDirectory schema extensions and press Next. Note: To remove the Formativ schema extensions you must first remove all Formativ objects from your eDirectory tree.
  5. Select the eDirectory tree for which you wish to extend the schema and press Next.
  6. At the confirmation screen, press Next to proceed with the selected action.

  7. If successful, you will see an action log displayed in the final dialog. If a problem has occurred, or perhaps just for your records, you can copy the log details to the clipboard by using the Copy to clipboard button. Press the Exit button to quit.

Formativ Classes and Attributes

The following Formativ classes are added to the eDirectory schema:

advansysFvConfig;

advansysFvScript;

advansysFvScriptLib.

The following Formativ attributes are added to the eDirectory schema:

advansysFvClientOptions;

advansysFvScriptEnabled;

advansysFvAppletSource (new in Formativ 1.5 - replaces advansysFvScriptSource);

advansysFvTimestamp (new in Formativ 1.5);

advansysFvLibType.

Note: Formativ 1.5 stores applets in a compressed format within eDirectory OCTET string attributes.


NDS Rights

eDirectory Rights

To manage a Formativ eDirectory environment, you need to allocate the appropriate rights to users accessing Formativ eDirectory objects, such as the Configuration, Applet Library, Applet and FormativAdministrator objects. Table 1 below illustrates the eDirectory rights required for each object.

Formativ eDirectory Object

eDirectory Rights Configuration

Configuration

Formativ User: No additional rights assignment required. When a Configuration object is created, the necessary rights are automatically assigned (Entry Browse and Property Read/Compare rights).

Note: The following assumes that the search option is not disabled in the Formativ Control Panel applet. If the Configuration object reference is not found in the User object's See Also property when Formativ starts, it will automatically search the See Also property of the User, Group, Organizational Unit (OU) and Organization (O) objects for a Configuration object reference.

For the Group, OU and O objects to be searched successfully, the See Also property of these objects must be visible to the User object. The appropriate eDirectory rights are automatically assigned (to an object containing a Configuration object reference) when using the Associate feature from the Configuration object's Formativ Configuration property page.

Applet Library

Formativ User: No additional rights assignment required. When a Configuration object is created, the necessary rights are automatically assigned (Entry Browse and Property Read/Compare rights).

Formativ Applet Library Administrator: The eDirectory administrator must assign to Applet Library Administrators the [Entry] Browse, Create, Delete, Rename, Inheritable and [All Attributes] Compare, Read, Write, Inheritable rights to the Applet Library objects they administer (see hint below).

Applet

No additional rights assignment required. The appropriate rights for both the Formativ User and the Formativ Applet Library Administrator should be automatically inherited from their Applet Library rights.

FormativAdministrator

The FormativAdministrator Organizational Role does not require any special access rights. See hint below.

Hint: The FormativAdministrator object offers a quick and convenient way to assign the rights required to administer a Applet Library. Since the Security Equal to Me property of the FormativAdministrator role object is assigned to users who can run Formativ Admin in Administration Mode, you can assign to the FormativAdministrator role object the [Entry] Browse, Create, Delete, Rename, Inheritable and [All Attributes] Compare, Read, Write, Inheritable rights to all Formativ Applet Libraries in your eDirectory tree. This action will automatically provide the required Applet Library administration rights to users who are assigned the FormativAdministrator role. All that is then required is to assign the appropriate FormativAdministrator users as Library Administrators of one or more Applet Libraries.

NOTE: Please note that in this guide that the eDirectory term 'property' may be interchanged with the eDirectory term 'attribute'.

Table 1: eDirectory rights configuration for Formativ eDirectory objects

Figure 1 below illustrates a possible configuration of the Formativ objects within the eDirectory tree. In this example, under the Advansys Organization a Formativ Organizational Unit has been created, which contains the Formativ Configuration, Applet Library and FormativAdministrator role objects.

Figure 1 - Formativ objects in a Formativ Organizational Unit


Formativ NDS Objects

Formativ eDirectory Objects

Formativ provides three new eDirectory objects, listed below, which are used to manage Formativ applets, Formativ Admin, Formativ Developer and Formativ Runtime features and end-user access to Applet Libraries.

Configuration Object

Applet Library Object

Applet Object

The Formativ Configuration Object [image] is an eDirectory leaf object which contains information about:

how Formativ is configured within the user's GroupWise client and

which Formativ features are active for user.

A Configuration Object also contains a list of Applet Library Objects available to users assigned to the Configuration Object. Configuration Objects can only be created by an eDirectory Administrator using either NWAdmin or ConsoleOne. For more details see The Configuration Object

The Formativ Applet Library Object [image] is a container object. It can only contain Formativ Applet Objects [image]. It is used to:

logically group shared Formativ Applet objects in the eDirectory tree and

define the user(s) who will administer the applets in the library;

Applet Library objects can only be created by an eDirectory administrator using either NWAdmin or ConsoleOne. For more details, see The Applet Library Object.

The Formativ Applet Object [image] is a leaf object which contains applet source code and GroupWise integration information (i.e. how the applet should be integrated with the GroupWise client, such as toolbar buttons, menu items and events). Formativ Applet objects can only be created by Formativ Admin when used by a Formativ user with special Administrator rights. Applet objects can only be created within the Applet Library container object. For more details see The Applet Object.

Below is an example illustratration of a simple eDirectory tree view where the three Formativ Applet objects have been created.

Simple tree view showing the three Formativ objects


The Configuration Object

The Formativ Configuration Object [image] is used to store and control:

the details of one or more shared applet libraries to which a user will have access (see Figure 1 and 2) and

which Formativ features are visible within a user's GroupWise client, such as the ability to create personal applets (see Figure 3).

Every Formativ user needing access to shared applets in eDirectory must have access to a single Configuration object. A user cannot have access to more than one Configuration object. Configuration objects can only be created with eDirectory administration tools, such as NWAdmin or ConsoleOne, which have the Formativ snapins installed.

Configuration Object - Applet Libraries Page

The Configuration object's Applet Libraries page is administered by using either NWAdmin or ConsoleOne. By using the Add or Remove buttons, you can add or remove references to Formativ Applet Libraries which will then be accessible to any user who is assigned to this Configuration object. In the example below the user has access to the Global Configuration:

Figure 1 - Configuration object 'Global Configuration' provides access to the Applet Library 'Global Applets'

Figure 2 - Configuration object 'Accounting Configuration' provides access to the Applet Libraries 'Accounting Applets' and 'Global Applets'

Configuration Object - Formativ Configuration Page

The Configuration object has the following properties which can be administered by using either NWAdmin or ConsoleOne:

Figure 3 - Configuration object's Formativ configuration page.

Description

Provides a more descriptive name for the configuration object. This value is not used outside the administration environment.

Formativ is enabled

Enable or disable Formativ on a user's PC.

Integrations enabled

Used to enable or disable applet integrations (toolbar buttons, menu items or events) for users associated with this Configuration object.

Update applet cache on client startup

In Formativ 1.0 this setting was called 'Reload shared applets on GroupWise client startup'. When this option is enabled, the user's subscribed eDirectory Formativ applet libraries are always accessed on client startup to ensure that the Formativ workstation's local applet cache, located under the c:\program files\advansys\formativ\mirror\ folder, is always up to date. This procedure ensures that the Formativ user is always running the latest applet version stored in eDirectory. The update process varies according to the 'Enable intelligent applet caching' setting (see below). To maintain a local, fast access eDirectory applet 'mirror', this setting should be enabled for most environments.

Enable intelligent applet caching

In Formativ 1.0, this setting was called 'Enabled when using GroupWise Remote'. In Formativ 1.5 and above, the operation of this feature has been enhanced to work in conjunction with the 'Update applet cache on client startup', which must be enabled for the intelligent caching option to work. As in Formativ 1.0, enabling this option prevents the local workstation applet cache from being cleared when you exit the GroupWise client. Intelligent applet caching, introduced in Formativ 1.5, works by the Formativ client interrogating a Formativ library applet UTC 'timestamp', which is set when the applet is published to eDirectory by Formativ Admin 1.5 or Formativ Developer 1.5 (you must extend the schema using the Formativ 1.5 Schema Wizard to use this feature). This means that an applet will only be downloaded from eDirectory if the applet stored in the local workstation cache has a timestamp which is older than the library applet's timestamp. The result is minimum traffic over the network and fast GroupWise client startup, without sacrificing the benefits of centralized distribution and management via eDirectory. If you wish to use eDirectory Formativ applet libraries with GroupWise Remote, the 'Enable intelligent applet caching' option must be enabled.

Create and manage personal applets

Enable and disable the user's ability to create personal applets. This setting has no effect when using Formativ Runtime. Formativ Runtime does not provide applet creation or recording.

Record personal applets

Enable and disable the ability to record applets in the GroupWise client. The 'Create and manage personal applets" option must also be selected in order for this option to be enabled. This setting has no effect when using Formativ Runtime. Formativ Runtime does not provide applet creation or recording.

Run menu enabled

Enable and disable the Formativ | Run menu in the GroupWise client.

Favorites menu enabled

Enable and disable the Formativ | Favorites menu in the GroupWise client.

Object Associations

The Associate button is used to assign the Formativ Configuration object to a User, Group, Organizational Unit or a Organization eDirectory object (see the section below for an explanation of which target object to use). Assigning the Configuration object to a target object with the Associate button performs the following functions:

  1. removes any old Configuration object references from the target object's See Also property;
  2. adds the Configuration object reference (its FDN) to the target object's See Also property and
  3. ensures that the minimum required eDirectory rights are assigned to the target object's See Also property ([Entry] Browse, [Property] Read, Compare).

Note: You should always use the Associate button to assign a Formativ Configuration object to a target eDirectory object (User, Group, Organizational Unit or Organization). This method ensures that the correct See Also reference and eDirectory rights are assigned automatically.

Associating a Formativ User with a Formativ Configuration Object

The four ways to create a link between a user and their Formativ Configuration object are:

directly point to a Configuration object in the User's [image] See Also property (see Figure 4);

point to a Configuration object in a Group's [image] See Also property (the user must be a member of the Group) (see Figure 5);

point to a Configuration object in an Organizational Unit object's [image] See Also property (the user must be located somewhere in the branch below the OU) (see Figure 6); and

point to a Configuration object in an Organization object's [image] See Also property (the user must be located within the Organization's structure).

When Formativ starts the See Also properties of the following objects are searched, in the order shown below, until a Formativ Configuration object reference is found.

  1. User's User object
  2. Groups [image] in which the user is a member
  3. Organizational Units [image] (OU) in the branch where the User object exists, starting from the OU which is closest to the User object
  4. Organization [image] (O) to which the user belongs.

Formativ will stop searching eDirectory as soon as a Formativ Configuration reference is found in one of the objects listed above. If no Formativ Configuration objects are found, Formativ attempts to use the last valid settings from the Windows registry. If no Configuration objects are located in eDirectory and no offline settings can be found in the Windows registry, Formativ does not load.

Note 1: If the Configuration object reference is not found in the User object's See Also property when Formativ starts, it will automatically search the See Also property of the User, Group, Organizational Unit (OU) and Organization (O) objects for a Configuration object reference. For the Group, OU and O objects to be searched successfully, the See Also property must be visible to the User object. This means that the User object must have Entry Browse and Compare/Read rights to the See Also property of any Group, OU or O objects to be searched.

You should always use the Associate button to assign a Formativ Configuration object to a target eDirectory object (User, Group, Organizational Unit or Organization). This method ensures that the correct See Also reference and eDirectory rights are assigned automatically.

Note 2: Formativ will not search Group, Organizational Unit or Organization objects if these features are disabled in the Formativ Control Panel settings (see Note 3 below).

Which eDirectory object should reference the Formativ Configuration Object?

You can use four eDirectory objects to reference a Formativ Configuration object: the User, Group, Organizational Unit or Organization. The decision to use one or more of these objects will depend on:

the level of convenience required when configuring access to Formativ Applet Libraries for multiple Formativ users and

whether you need to minimize eDirectory network traffic on GroupWise startup.

Table 1 below provides further information on how these eDirectory objects can be used to reference a Formativ Configuration object.

Note 3: To limit eDirectory tree scanning in limited bandwidth environments, you can set the maximum number of OU levels which Formativ will scan when it starts up, using the Formativ Windows Control Panel applet. Setting the search OU levels to 0 prevents any OUs from being searched. An additional control panel setting allows you to prevent Formativ from searching Group objects.

eDirectory Object

When to use the object to point to a Formativ Configuration Object

User

As the User object is the first place Formativ checks for a valid Formativ Configuration object reference, using this property is the most direct and most granular approach.

Benefits: The Administrator can assign Formativ Configuration objects to specific users. These will override any Formativ Configuration object references in the user's Group or upline OU objects. For example, a 'power user' or Applet Library Administrator could be given access to a special Configuration Object, which provides them with privileged access to a wider range of Applet Libraries and Formativ features. The User object approach also reduces access time to eDirectory information because Formativ does not need to search through the Group or Organizational Unit object's See Also property (although this saving may be unnoticeable in most network environments).

Disadvantages: Requires additional administrative overhead to configure or reconfigure the User object's See Also property.

Group

The Group object is a convenient way to associate a number of users, regardless of their position within the Organizational Unit structure, with a Formativ Configuration object. A user's Group membership is searched if Formativ cannot find a Formativ Configuration object in the user's User object. This object will not be searched if the Group search option is disabled in the Formativ Control Panel settings (see Note 1 above).

Benefit: Easy to configure a number of users to use a Formativ Configuration object (see Note 1 above).

Disadvantage: Requires Formativ to scan the user's Group memberships on startup.

Organizational Unit

The Organizational Unit object provides an even higher level approach to assigning a Formativ Configuration object to a number of users. To cater for users who do not have a Formativ Configuration reference within their Group memberships or their User object, the Organizational Unit can easily be used to provide default access to a Formativ Configuration object.

The Formativ Configuration object reference is not limited to the immediate Organizational Unit to which the user belongs - it can be included in any upline Organizational Unit which forms part of the Fully Distinguished Name (FDN) path to the user's User object. This object will not be searched if the Group, OU or O object search option is disabled in the Formativ Control Panel settings (Windows Control Panel).

To limit scope of Formativ's eDirectory scan for a Configuration object, in the Formativ Control Panel settings you can also limit the number of levels of OUs searched. Setting the search OU levels to 0 prevents any OUs from being searched (see Note 3 above).

Benefits: Provides a very convenient way to provide access to a Formativ Configuration object for a potentially large number of users. Can also provide access to a higher level 'default' Formativ Configuration (see Note 1 above).

Disadvantage: Requires Formativ to scan the user's Group memberships and Organizational Units within their FDN. However, as soon as a Formativ Configuration object is found within an upline Organizational Unit, the scan will stop.

Organization

The Organization object to which the user belongs is the highest level eDirectory object which can contain a Formativ Configuration reference. This object would normally be used to provide access to an organization wide default Formativ Configuration object (see Note 1 above).

Benefit: Provides the easiest and quickest way to provide access to a default Formativ Configuration object for all users within an eDirectory organization structure (see Note 1 above).

Disadvantage: If no Formativ Configuration object reference is found in the User, Group and Organizational Unit objects, the Organization object is the last object to be scanned by Formativ.

Table 1: eDirectory Objects which can refer to Formativ Configuration Objects

Figure 4 - User Jon Jone's See Also property pointing to a Formativ Configuration object (Power User Configuration)

Figure 5 - Group 'Special Applet Users' See Also property pointing to a Formativ Configuration object (Special Configuration)

Figure 6 - Organizational Unit 'Accounting' See Also property pointing to a Formativ Configuration object (Accounting Configuration)


The Applet Library Object

The Formativ Applet Library Object [image] is used to group Formativ Applet Objects. For example, you might create a Applet Library Object for each Organizational Unit in the eDirectory tree, plus a master library object which is shared by all users in the tree. The Applet Library object also allows you to specify one or more users, called Formativ Library Administrators, who are authorized to create, edit and delete applets within the library (see also Administration Mode and Using the client in Administration Mode).

Applet Library objects can only be created with the appropriate eDirectory administration tools, such as NWAdmin or ConsoleOne, which have the Formativ snapins installed.

Applet Library Object Properties

The Applet Library object has the following properties on the Library Settings Page which can be administered by using either NWAdmin or ConsoleOne:

Description

Provides a more descriptive name for the Applet Library object. This value is not used outside the administration environment.

Applet Library Administrators

The Applet Library object's Library Administrators Page allows you to specify which users are authorized to create, edit and delete applets within the library. Use the Add and Remove buttons to add and remove users as Applet Library administrators, who must also be assigned to the FormativAdministrator Organizational Role [image] (see Administration Mode and Using the client in Administration Mode).

Figure 1 - User Jon Jones is configured to be a Formativ Library Administrator for the 'Global Applets' Applet Library


The Applet Object

The Formativ Applet Object [image] is used to store a single Formativ Applet in eDirectory. Applet objects, which can only be contained in a Formativ Applet Library object, are created in eDirectory by using Formativ Admin in administration mode.

Applet Object Properties

The Applet object has the following property which can be administered by using either NWAdmin or ConsoleOne:

Applet is Visible

Controls the visibility of a Applet object to Formativ users. If a Applet object is not visible, it is not seen by Formativ and therefore cannot be executed.

A simple tree view showing Applet objects can be see by clicking here.


Administrator Mode

The Formativ Admin can operate in two modes, standard or Administrator. When Formativ Admin operates in standard mode, it provides access to Formativ applets and Formativ features specified in the users eDirectory Configuration object. The Formativ Admin's Administrator mode is used by one or more authorized Formativ Applet Library administrators to add, delete or edit Formativ Applet objects which belong to one or more Applet Library objects.

Formativ Developer and Formativ Runtime do not include any eDirectory administration options, and cannot run in Administrator mode.

If the current user has security equal to an eDirectory Organizational Role [image] called 'FormativAdministrator', which must be created manually by the eDirectory administrator, Formativ Admin will start automatically in Administrator mode.

Assigning a user as a Formativ Applet Library Administrator

The eDirectory administrator must first create an eDirectory Organizational Role [image] called 'FormativAdministrator'. The spelling must be exact and must not include a space between the words Formativ and Administrator, i.e. it must be the single word, FormativAdministrator. To assign a user as a Applet Library Administrator, simply enter a reference to the user within the Security Equal To Me page of the FormativAdministrator Organizational Role object [image].

Note: In order for the Formativ Admin to operate in Administration mode, a user must be assigned as a FormativAdministrator, which enables them to manage Formativ Applet Libraries. However, the eDirectory administrator must also specifically assign the user to the Applet libraries which they are to administer (see The Applet Library Object).


Using the client in Administration Mode

Using Formativ in Administration Mode

If you have security equal to the FormativAdministrator Organizational Role object [image], Formativ Admin will start in Administration mode , which is a prerequisite for managing applets within Formativ Applet Libraries. To administer one or more Applet Libraries, you must be assigned as the Library Administrator in the target libraries by the eDirectory administrator (see The Applet Library Object). Our discussion below will assume that these configuration steps have been completed. Formativ Developer and Formativ Runtime do not offer any eDirectory administrative options, and cannot be run in Administration mode.

Administrator Mode Concepts

Administrator mode is a powerful centralized management feature which tightly integrates the Formativ IDE (FormativCentral) with eDirectory. It enables a Formativ Administrator to manipulate Formativ Applet objects directly within Applet Libraries. New or updated applets published to a shared Applet Library in eDirectory are immediately available to Formativ users subscribed to the updated Applet Library (see The Configuration Object for an explanation of how a user becomes subscribed to a Applet Library). Assuming that you have the appropriate eDirectory rights when logged in, Administrator mode allows you conveniently to add, edit, delete and rename applets in a Applet Library from any workstation on the network.

Apart from the obvious productivity benefits provided by centralized management of Formativ Applet Libraries, it is possible to use this feature in many ways. For example, you could roll-out an applet which, by linking it to the On Startup GroupWise event on the Formativ Integrations page, performs an action on the GroupWise client and then disables itself (a 'run once' applet). The applet could even be set up to send an email to identify which users had started their GroupWise client (and hence the applet). You could then remove the applet from the Applet Library after providing sufficient time for all users to have run the applet or after having received the expected number of automatic response emails.

Note: When a new or updated applet is published to a Applet Library, Formativ users must restart their GroupWise client for the applet change to be effected on their workstation.

After starting your GroupWise client, select the menu Applets | Manage Applets, or the Manage all your macros from Formativ Central toolbar button, to start the FormativCentral integrated development environment (IDE). When in Administrator mode, FormativCentral will display the text 'Administrator Mode (<your email address>)', where <your email address> is the current user's (usually yours) GroupWise email address. On the left, Formativ displays the list of Applet Libraries to which you have access. If you don't have access to any Libraries, the only entry displayed is My Applets, which represents your local personal applets. Personal applets are usually stored on your workstation in the 'c:\program files\advansys\formativ\local\' directory or in a personal directory on the network.

If your Formativ Configuration object [image] provides access to Formativ Applet Libraries [image] in eDirectory, you will see the library names listed below the My Applets entry. In the example below (Figure 1), the Administrator user admin (admin.GWDEVPO.GWDEVDOM) has access to three Formativ Applet Libraries in eDirectory called Applet Development Library, HO Applet Library and Global Corporate Applets. Applet Library administration rights are identified by a hammer [image] symbol at the end of the applet library name, and user admin [image] only has rights to administer two libraries, Applet Development Library and Global Corporate Applets (not the HO Applet Library). Thus, while user admin can run applets contained in HO Applet Library, that library's applets cannot be modified by the user in any way. The eDirectory environment which enables this configuration is listed below.

The Formativ Configuration Object [image] , to which user admin is linked, provides access to three Formativ Applet Libraries [image] in eDirectory called Applet Development Library, HO Applet Library and Global Corporate Applets. For details on how Applet Libraries are configured within a Configuration object, see section The Configuration Object.

The Formativ Applet Libraries [image], Applet Development Library and Global Corporate Applets, include user admin in its Library Administrators configuration. Applet Library HO Applet Library does not include user admin as a Library Administrator.

User admin [image] is included in the Security Equal to Me configuration of the FormativAdministrator Organizational Role [image].

Figure 1 - Formativ in Administrator mode showing both personal and shared eDirectory Formativ Applet Libraries

The Formativ eDirectory Publishing System

Administration mode operates on the same basis as standard mode where, upon GroupWise client startup, the shared Applet Library applets are copied from eDirectory and cached (mirrored) on the user's local workstation (for faster access and to reduce network traffic). Depending on your Configuration Object settings, these 'cached' applet copies may or may not be deleted when the GroupWise client shuts down.

When a Formativ Administrator edits a shared library, applet changes are only made to the local cached copy of the applet. As soon as the applet is modified, the symbol [image] appears at the end of the applet name. The [image] symbol indicates that, to make the locally updated applet available from eDirectory, the applet must be published back to its eDirectory Applet Library by the Formativ Administrator. This process is described in more detail below.

Managing Applet Libraries

User Advansys is able to administer Applet Development Library and Global Corporate Applets, which means that user Advansys can perform the following actions on these libraries. These actions are described in more detail below:

add applets;

edit applets;

delete applets;

rename applets.

Note: Library modifications become immediately available to Formativ users after they restart their GroupWise client, thus modifying shared Applet Libraries should be done with CAUTION!

Adding Applets to an Applet Library

In Formativ Administration mode, the are three methods for adding a applet to a shared Applet Library:

  1. Use the New button to create a new applet directly in a shared applet library;

  2. Use the New button to create a new applet in My Applets and then when ready, copy or move it to the destination library (see Copy and Moving Applets between Libraries below);

  3. Copy or move an existing applet from My Applets or another shared library to the destination library.

Note: When you copy or move the applet from My Applets into the destination library, it is automatically and immediately published to eDirectory - you will not see the [image] symbol appear.

Editing Applets in a Applet Library

As a Formativ Administrator, you can edit the local cached copy of the shared library and publish it back to its eDirectory Applet Library location at any time during the same GroupWise session. When you modify a shared applet in Formativ, the [image] symbol will appear at the end of the applet name. The [image] symbol indicates that the applet must be manually published to eDirectory before the updated applet will be available from its parent Applet Library. You can publish the applet at any time to its eDirectory Applet Library by highlighting the applet, displaying the right-mouse context menu and selecting the Publish menu entry. Upon successful publishing to eDirectory, the [image] symbol will disappear from the end of the shared applet name. Figure 1 above shows that the Search and Replace applet from the Global Corporate Applets library needs to be published back to eDirectory.

If the GroupWise client is shut down before modified applets have been published manually, a message will appear warning the Formativ Administrator and offering the option to publish it. If the publish is not performed, the applet updates will be lost.

Hint: Unless the modifications are very minor, it is generally not recommended that you edit shared applets while they reside under their shared library. To prevent publishing any unforeseen coding errors, a better approach is to copy and edit them in My Applets or a specially allocated development library, which is not shared with other GroupWise users (unless they belong to your test team). The benefit of a separate development library is that you always have a backup in eDirectory and the applets can be accessed by Formativ from any workstation. When the changes are finished and tested, the applet can be copied or moved from My Applets or the development library into the active online applet library.

Deleting Applets from a Applet Library

Highlight the shared applet you wish to delete and use the right-mouse context menu to delete it. The delete action will remove the local applet copy and the one from the eDirectory Applet Library, thus if you do not have a backup copy, use the delete action with CAUTION.

Renaming Applets in a Applet Library

You can rename applets in the same way you can rename files in Windows Explorer. Simply highlight the applet and click again onto the applet name for the editing cursor to appear. Make the desired changes and press enter or click somewhere else in Formativ. The [image] symbol will appear at the end of the applet name, which indicates that the changes must be manually published to eDirectory. You can publish the applet at any time to its eDirectory Applet Library by highlighting the applet, displaying the right-mouse context menu and selecting the Publish menu entry. Upon successful publishing to eDirectory, the [image] symbol will disappear from the end of the shared applet name.

Copying and Moving Applets between Libraries

You can copy and move applets between libraries by using the standard Windows drag/drop feature:

To move an applet from either My Applets or a shared library, highlight the applet, hold down the left mouse button and drag the applet over the destination library name, then release the left mouse button. You should see the applet appear in the destination library in Formativ and it should disappear from the source library. The moved applet is automatically and immediately published to eDirectory - you will not see the [image] symbol appear.

To copy an applet from either My Applets or a shared library, highlight the applet, hold down both the control key and the left mouse button, and drag the applet over the destination library name (the cursor should have a + sign indicating a copy rather than a move operation), then release the left mouse button. You should see the applet appear in the destination library in Formativ and the original applet should still exist in the source library. The copied applet is automatically and immediately published to eDirectory - you will not see the [image] symbol appear.

Exiting GroupWise

If the GroupWise client is closed before modified applets have been published manually, a message will appear warning that the changes will be lost, and offering the option to publish them. If the publish is not performed, the applet updates will be lost. If the publish is carried out, all unpublished applets will be published to eDirectory.